#ifndef LOADERTHREAD_H_INCLUDED
#define LOADERTHREAD_H_INCLUDED

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
 #include <wx/wx.h>
#endif

extern const wxEventType wxEVT_LOADERTHREAD_ENDED;
extern const wxEventType wxEVT_LOADERTHREAD_ERROR;
extern const wxEventType wxEVT_LOADERTHREAD_CANCEL;
extern const wxEventType wxEVT_LOADERTHREAD_STATE;

#define EVT_LOADERTHREAD_ENDED(id, fn) \
    DECLARE_EVENT_TABLE_ENTRY( \
        wxEVT_LOADERTHREAD_ENDED, id, wxID_ANY, \
        (wxObjectEventFunction)(wxEventFunction) wxStaticCastEvent( wxCommandEventFunction, &fn ), \
        (wxObject *) NULL \
    ),
#define EVT_LOADERTHREAD_ERROR(id, fn) \
    DECLARE_EVENT_TABLE_ENTRY( \
        wxEVT_LOADERTHREAD_ERROR, id, wxID_ANY, \
        (wxObjectEventFunction)(wxEventFunction) wxStaticCastEvent( wxCommandEventFunction, &fn ), \
        (wxObject *) NULL \
    ),
#define EVT_LOADERTHREAD_CANCEL(id, fn) \
    DECLARE_EVENT_TABLE_ENTRY( \
        wxEVT_LOADERTHREAD_CANCEL, id, wxID_ANY, \
        (wxObjectEventFunction)(wxEventFunction) wxStaticCastEvent( wxCommandEventFunction, &fn ), \
        (wxObject *) NULL \
    ),
#define EVT_LOADERTHREAD_STATE(id, fn) \
    DECLARE_EVENT_TABLE_ENTRY( \
        wxEVT_LOADERTHREAD_STATE, id, wxID_ANY, \
        (wxObjectEventFunction)(wxEventFunction) wxStaticCastEvent( wxCommandEventFunction, &fn ), \
        (wxObject *) NULL \
    ),

class RBLoader;
#include "RB_SongList.h"

class LoaderThread : public wxThread
{
public:
    LoaderThread(RBLoader* parent=NULL,int id=-1);
    virtual ~LoaderThread();
    virtual void* Entry();
    void SetAssociatedControls(wxGauge* gauge=NULL,wxStaticText* label=NULL);
    void SetSongVar(RB_Song* song);
    void StopRunning();
protected:
private:
    bool bStopWanted;
    RBLoader* prntctrl;
    wxGauge* pgb;
    wxStaticText* txtinfos;
    RB_Song* currsong;
};

#endif // LOADERTHREAD_H_INCLUDED
