#include "mainframe.h"
#include "welcomepanel.h"
#include "searchpanel.h"
#include "playerpanel.h"

#ifndef __WXMSW__
#include "wxWidgets.xpm"
#endif

int ID_NoteBook=wxNewId();

BEGIN_EVENT_TABLE(MainFrame,wxFrame)
    EVT_NOTEBOOK_PAGE_CHANGED(ID_NoteBook,MainFrame::OnNotebookPageChanged)
    EVT_LOADERTHREAD_ENDED(-1,MainFrame::OnLoadFinished)
END_EVENT_TABLE()

MainFrame::MainFrame():wxFrame(NULL,-1,_T("wxRadioBlog Player"),wxDefaultPosition,wxSize(600,410))
{
    SetIcon(wxICON(amainicon));
    mainpanel=new wxPanel(this,-1);
    wxBoxSizer* sizer1=new wxBoxSizer(wxVERTICAL);
    nbook=new wxNotebook(mainpanel,ID_NoteBook);
        welcome=new WelcomePanel(nbook);
        nbook->AddPage(welcome,welcome->GetTitle());
        search=new SearchPanel(nbook);
        nbook->AddPage(search,search->GetTitle());
        player=new PlayerPanel(nbook);
        nbook->AddPage(player,player->GetTitle());
    sizer1->Add(nbook,1,wxALL|wxEXPAND,5);
    mainpanel->SetSizer(sizer1);
    sizer1->SetSizeHints(mainpanel);

    CreateStatusBar();
    SetStatusText(_T("Pr\352t..."));
    nbook->SetSelection(1);
}

MainFrame::~MainFrame()
{
    //dtor
}

void MainFrame::OnNotebookPageChanged(wxNotebookEvent& event)
{
    wxString sTitle=_T("wxRadioBlog Player :: ");
    int ipage=event.GetSelection();
    if (ipage!=1)
    {
        PagePanel* curr=(PagePanel*)nbook->GetPage(ipage);
        sTitle.Append(curr->GetTitle());
    } else {
        sTitle=_T("wxRadioBlog Player :: Recherche");
    }
    SetTitle(sTitle);

}

void MainFrame::OnLoadFinished(wxCommandEvent &event)
{
    player->UpdatePlayList();
}
