#include "myapp.h"
#include "mainframe.h"
#include <wx/fs_inet.h>

#ifdef _MSC_VER
    #pragma comment(lib,"user32.lib")
    #pragma comment(lib,"ole32.lib")
    #pragma comment(lib,"oleaut32.lib")
    #pragma comment(lib,"shell32.lib")
    #pragma comment(lib,"gdi32.lib")
    #pragma comment(lib,"comdlg32.lib")
    #pragma comment(lib,"advapi32.lib")
#endif  //_MSC_VER

#ifdef _DEBUG
#include <crtdbg.h>
#include <stdio.h>

void DetectMemoryLeaks() 
{ 
	_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF); 
	_CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE); 
	_CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
}
#endif

#define MYAPP_CPP
#include "RB_SongList.h"
#include <wx/listimpl.cpp>

WX_DEFINE_LIST(RB_SongList)
RB_SongList MySongList;

IMPLEMENT_APP(MyApp);

bool MyApp::OnInit()
{
#ifdef _DEBUG
	DetectMemoryLeaks();
#endif
    wxFileSystem::AddHandler(new wxInternetFSHandler);
    MainFrame* frame=new MainFrame();
    frame->Show();
	return true;
}

int MyApp::OnExit()
{
    MySongList.DeleteContents(true);
    return wxApp::OnExit();
}
