#include "searchpanel.h"
#include "myprogressdlg.h"
#include "RB_SongList.h"
#include "globals.h"
#include <wx/listctrl.h>

static const int ID_TxtKWrds=wxNewId();
static const int ID_LstRes=wxNewId();
static const int ID_Loader1=wxNewId();
static const int ID_Loader2=wxNewId();

BEGIN_EVENT_TABLE(SearchPanel,wxPanel)
    EVT_BUTTON(wxID_FIND,SearchPanel::OnBtnSearchClicked)
    EVT_LISTBOX_DCLICK(ID_LstRes,SearchPanel::OnLstResultsDblClick)
    EVT_LOADERTHREAD_ENDED(-1,SearchPanel::OnRBLoaderEvent)
    EVT_LOADERTHREAD_ERROR(-1,SearchPanel::OnRBLoaderEvent)
    EVT_LOADERTHREAD_CANCEL(-1,SearchPanel::OnRBLoaderEvent)
END_EVENT_TABLE()

SearchPanel::SearchPanel(wxWindow* parent):PagePanel(parent,_T("Recherche"))
{
    wxBoxSizer* basesizer=new wxBoxSizer(wxHORIZONTAL);
        wxBoxSizer* leftsizer=new wxBoxSizer(wxVERTICAL);
            wxStaticBoxSizer* lszr1=new wxStaticBoxSizer(wxHORIZONTAL,this,_T("Mots clefs \340 rechercher : "));
                txtKeyWords=new wxTextCtrl(this,ID_TxtKWrds);
                lszr1->Add(txtKeyWords,1,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
                btnSearch=new wxButton(this,wxID_FIND,_T("Chercher"));
                btnSearch->SetDefault();
                lszr1->Add(btnSearch,0,wxBOTTOM|wxRIGHT|wxEXPAND,5);
            wxStaticBoxSizer* lszr2=new wxStaticBoxSizer(wxVERTICAL,this,_T("R\351sultats de la recherche : "));
                boxResults=lszr2->GetStaticBox();
                lstResults=new wxListBox(this,ID_LstRes);
                lszr2->Add(lstResults,1,wxALL|wxEXPAND,5);
            leftsizer->Add(lszr1,0,wxALL|wxEXPAND,5);
            leftsizer->Add(lszr2,1,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
        basesizer->Add(leftsizer,1,wxALL|wxEXPAND,0);
        wxBoxSizer* rightsizer=new wxBoxSizer(wxVERTICAL);
            wxStaticBoxSizer* rszr1=new wxStaticBoxSizer(wxHORIZONTAL,this,_T("Fichiers \340 charger : "));
                lstQueue=new wxListCtrl(this,-1,wxDefaultPosition,wxDefaultSize,wxLC_LIST);
                rszr1->Add(lstQueue,1,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
            rightsizer->Add(rszr1,1,wxALL|wxEXPAND,5);
            ldr1=new RBLoader(this,ID_Loader1,_T("Chargement fichier (thread 1) : "));
            rightsizer->Add(ldr1,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
            ldr2=new RBLoader(this,ID_Loader2,_T("Chargement fichier (thread 2) : "));
            rightsizer->Add(ldr2,0,wxLEFT|wxRIGHT|wxBOTTOM|wxEXPAND,5);
        basesizer->Add(rightsizer,1,wxALL|wxEXPAND,0);
    SetSizer(basesizer);
    txtKeyWords->SetFocus();
    // Initialisation des variables
    bIsSearching=false;
}

SearchPanel::~SearchPanel()
{
    //dtor
}

#ifdef _DEBUG
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#endif

void SearchPanel::OnBtnSearchClicked(wxCommandEvent &event)
{
    // Si on est dj en train de faire une recherche, on n'a rien  faire ici !
    if (bIsSearching==true) return;
    // Y a t'il quelque chose  chercher ?
    wxString sSearch=txtKeyWords->GetValue();
    int iLen=(int)sSearch.Length();
    if (iLen==0) return;

#ifdef _DEBUG
    // Enregistrement dans un fichier:
    wxFileOutputStream f_out(_T("Search_Result.txt"));
    wxTextOutputStream t_out(f_out);
#endif

    // On dsactive le bouton Chercher
    btnSearch->Enable(false);
    bIsSearching=true;
    // On affiche le wxDialog de recherche
    bool bStopFlag=false;
    MyProgressDlg prgdlg(GetGrandParent(),&bStopFlag);
    prgdlg.SetKeywords(sSearch);
    prgdlg.StartAutoPulse();

    wxString sUrl=_T("");
    wxString sRepl;
    int i,j,k;
    int iCurrPage=0;
    bool bNext=true;
    // On passe la recherche en minuscules
    sSearch.MakeLower();
    // On remplace les caractres non-autoriss
    wxString sAllowed=_T("abcdefghijklmnopqrstuvwxyz0123456789\340\342\344\347\350\351\352\353\356\357\364\371\373");
    for (i=0;i<iLen;i++)
    {
        if (sAllowed.Find(sSearch[i])==-1) sSearch[i]=_T('_');
    }
    // Vider la liste en mmoire
    songlist.Clear();
    // Vider le contrle ListBox
    lstResults->Clear();
    // Remettre  zro le nombre de rsultats trouvs
    boxResults->SetLabel(_T("R\351sultats de la recherche : "));
    wxString sPage,sTmp,sEntry,sName;
    while ((bNext)&&(!prgdlg.IsCancelled()))
    {
        // Construction de l'URL
        sUrl.Printf(_T("http://radioblogclub.com/search/%0d/"),iCurrPage*50);
        sUrl.Append(sSearch);
#ifdef _DEBUG
        t_out.WriteString(_T("Rsultat du chargement de la page :"));
        t_out.WriteString(sUrl);
        t_out.WriteString(_T("\n"));
#endif
        // chargement de la page correspondante
        sPage=LoadWebPage(sUrl,bStopFlag);
#ifdef _DEBUG
        t_out.WriteString(sPage);
        t_out.WriteString(_T("\n"));
#endif
        if (sPage==_T("_Cancelled_")) break;
        // Est-ce la dernire page ?
        // Pour le savoir, on recherche le bouton "Next" en haut de la page
        // S'il est suivi d'un </div>, et non d'un </a>, alors il est dsactiv...
        i=sPage.Find(_T("Next"))+4;
        if (sPage.Mid(i,6)==_T("</div>")) bNext=false;

        sTmp=sPage;
        // On recherche la premire entre qui nous intresse
        i=sTmp.Find(_T("<td><a href=\"/open/"));
        while (i!=-1)
        {
            sTmp.Remove(0,i+19);
            j=sTmp.Find(_T("\">"));
            k=sTmp.Find(_T("onClick"));
            if ((k==-1)||(k>j))
            {
                sEntry=sTmp.Left(j);
                //sEntry.Replace(_T("&amp;"),_T("&"),true);
                k=sTmp.Find(_T("</a></td>"));
                sName=sTmp.Mid(j+2,k-j-2);
                sName.Trim(false);
                //sName.Replace(_T("&amp;"),_T("&"),true);

                songlist.Add(sName + _T('\\') + sEntry );
                lstResults->Append(sName);
            }
            i=sTmp.Find(_T("<td><a href=\"/open/"));
        }
        sTmp.Printf(_T("R\351sultats : (%0d entr\351es trouv\351es)"),songlist.Count());
        boxResults->SetLabel(sTmp);
        iCurrPage++;
        if (songlist.Count()==0) bNext=false;
        sPage.Clear();
    }
    if (songlist.Count()==0) wxMessageBox(_T("Recherche infructueuse..."));

    btnSearch->Enable();
    bIsSearching=false;
}

void SearchPanel::OnLstResultsDblClick(wxCommandEvent &event)
{
    int iItm=event.GetSelection();
    if (iItm<0) return;
    int j=songlist[iItm].Find(_T('\\'));
    wxString sName=songlist[iItm].Left(j);
    wxString sUrl=songlist[iItm].Right(songlist[iItm].Length()-j-1);
    //wxMessageBox(_T("Loading : ") + sName +_T("\nUrl = ")+sUrl);
    AddToQueue(sName,sUrl);
}

void SearchPanel::AddToQueue(const wxString &name, const wxString &url)
{
    if (lstQueue->GetItemCount()==0) sLogMsg=_T("");
    RB_Song* newsong=new RB_Song;
    newsong->State=0;
    newsong->Name=name;
    newsong->Url=url;
    MySongList.Append(newsong);
    long l=lstQueue->InsertItem(lstQueue->GetItemCount(),name);
    lstQueue->SetItemData(l,(long)newsong);
    if (!StartNewJob(ldr1)) StartNewJob(ldr2);
}

bool SearchPanel::StartNewJob(RBLoader *loader)
{
    if (loader==NULL) return false;
    if (lstQueue->GetItemCount()==0)
    {
        // Si tous les chargements sont termins, afficher les ventuels
        // messages d'avertissement
        if ((ldr1->IsWorking()==false)&&(ldr2->IsWorking()==false))
        {
            if (!sLogMsg.IsEmpty())
            {
                wxMessageBox(_T("Il y a eut des avertissements :") + sLogMsg,_T("Erreurs de chargement"),wxICON_WARNING);
                sLogMsg=_T("");
            }
        }
        return false;
    }
    if (loader->IsWorking()) return false;
    RB_Song* newjob;
    for(long l=0;l<lstQueue->GetItemCount();l++)
    {
        newjob=(RB_Song*)lstQueue->GetItemData(l);
        if (newjob->State==0)
        {
            loader->SetCurrentJob(newjob);
            return true;
        }
    }
    // Si on arrive ici, c'est qu'il n'y a plus rien  faire
    return false;
}

void SearchPanel::OnRBLoaderEvent(wxCommandEvent &event)
{
    int i=event.GetId();
    RBLoader* loader=(i==ID_Loader1)?ldr1:ldr2;
    RB_Song* oldjob=loader->GetCurrentJobPtr();
    long itm=lstQueue->FindItem(-1,(long)oldjob);
    lstQueue->DeleteItem(itm);
    if (event.GetEventType()==wxEVT_LOADERTHREAD_ENDED)
    {
        // Passer l'vnement  la wxFrame pour qu'elle
        // Demande au PlayerPanel de mettre  jour la PlayList
        event.Skip();
    } else {
        if (event.GetEventType()==wxEVT_LOADERTHREAD_ERROR)
        {
            // Avertir l'utilisateur qu'une erreur s'est produite
            sLogMsg << _T("\nErreurs lors du chargement de : ") << oldjob->Name;// << _T("\nUrl=") << oldjob->Url.mb_str();
        }
        // Supprimer l'entre de la liste en mmoire
        MySongList.DeleteObject(oldjob);
        delete oldjob;
    }
    loader->SetCurrentJob(NULL);
    StartNewJob(loader);
}
